"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseClickHouseWithoutCursor = exports.parseClickHouse = exports.parsePostgreSqlWithoutCursor = exports.parsePostgreSql = exports.parseGenericSqlWithoutCursor = exports.parseGenericSql = exports.Parser = exports.cursorSymbol = void 0;
const clickhouseAutocompleteParser_1 = require("./parsers/clickhouse/clickhouseAutocompleteParser");
const genericAutocompleteParser_1 = require("./parsers/generic/genericAutocompleteParser");
const postgresqlAutocompleteParser_1 = require("./parsers/postgresql/postgresqlAutocompleteParser");
__exportStar(require("./lib/autocomplete-parse-result"), exports);
exports.cursorSymbol = '†';
class Parser {
}
exports.Parser = Parser;
function parseGenericSql(queryBeforeCursor, queryAfterCursor) {
    const parser = genericAutocompleteParser_1.genericAutocompleteParser;
    return parser.parseSql(queryBeforeCursor, queryAfterCursor);
}
exports.parseGenericSql = parseGenericSql;
function parseGenericSqlWithoutCursor(query) {
    return parseGenericSql(getFinishedQuery(query), '');
}
exports.parseGenericSqlWithoutCursor = parseGenericSqlWithoutCursor;
function parsePostgreSql(queryBeforeCursor, queryAfterCursor) {
    const parser = postgresqlAutocompleteParser_1.postgresqlAutocompleteParser;
    return parser.parseSql(queryBeforeCursor, queryAfterCursor);
}
exports.parsePostgreSql = parsePostgreSql;
function parsePostgreSqlWithoutCursor(query) {
    return parsePostgreSql(getFinishedQuery(query), '');
}
exports.parsePostgreSqlWithoutCursor = parsePostgreSqlWithoutCursor;
function parseClickHouse(queryBeforeCursor, queryAfterCursor) {
    const parser = clickhouseAutocompleteParser_1.clickhouseAutocompleteParser;
    return parser.parseSql(queryBeforeCursor, queryAfterCursor);
}
exports.parseClickHouse = parseClickHouse;
function parseClickHouseWithoutCursor(query) {
    return parseClickHouse(getFinishedQuery(query), '');
}
exports.parseClickHouseWithoutCursor = parseClickHouseWithoutCursor;
function getFinishedQuery(query) {
    // If our finished query is "SELECT * FROM|" and we try to parse it, parser thinks that we still haven't finished writing it and doesn't show some errors.
    // In order to truly complete a finished query, we need to add space to it like so "SELECT * FROM |".
    return query + ' ';
}
